;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname cc2-gr1) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write mixed-fraction #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; cc2-gr1.rkt
;;; Fac Sciences Nice, L1-Info, Printemps 2017
(require net/sendurl)

;;; Question 1a

(define (derivee f)                ; TP2 exo 4 !!
  (local [(define h #i0.001)]
    (lambda (x) (/ (- (f (+ x h)) (f x)) h))))

(show ((derivee log) 2))           ; environ 1/2

;;; Question 1b

(define (derivee-nieme f n)
  (if (zero? n)
      f
      (derivee (derivee-nieme f (- n 1)))))       ; recursive enveloppee

(show ((derivee-nieme log 2) 2))   ; environ -1/4

;;; Question 1c

(define (derivee-nieme-it f n)
  (if (zero? n)
      f
      (derivee-nieme-it (derivee  f) (- n 1))))   ; recursive terminale

(show ((derivee-nieme-it log 2) 2))

;;; Question 1d

(define (fac n)
  (apply * (range 1 (+ n 1) 1)))

(check-expect (fac 5) 120)

;;; Question 1e

(define (taylor f a n)    ; le polynome de Taylor d'approximation de f en x=a a l'ordre n
  (lambda (x)
    (apply + (build-list (+ n 1) (lambda (k) (* (/ ((derivee-nieme f k) a) (fac k)) (expt (- x a) k)))))))

(send-url "http://www.math.univ-toulouse.fr/~jgillibe/enseignement/MHT204_chap4.pdf")
(printf "Soit p le polynome de Taylor de sin(x) en x=0 a l'ordre 5 :\n")
(define p (taylor sin 0 5))
(show (p (/ pi 10)))
(show (sin (/ pi 10)))

;;; Question 2

(define (blackhole)
  (local [(define FOND (rectangle 800 600 'solid 'black))
          (define-struct astre (r theta dr color))
          (define INIT empty)
          (define (random-astre)
            (make-astre 500 (* 2 pi (random)) (+ (* 5 (random)) 5)
                        (make-color (random 256) (random 256) (random 256))))
          (define (dessiner L)
            (reduce (lambda (part scene)
                      (local [(match-define (astre r theta v color) part)]
                        (place-image (circle (/ r 10) 'solid color)
                                     (+ 400 (* r (cos theta))) (+ 300 (* r (sin theta)))
                                     scene)))
                    FOND
                    L))
          (define (suivant L)
            (if (empty? L)
                (list (random-astre))   ; 1 nouvel astre a chaque top d'horloge
                (local [(match-define (astre r theta dr color) (first L))
                        (define new-r (- r dr))
                        (define HR (suivant (rest L)))]
                  (if (<= new-r 0)
                      HR
                      (cons (make-astre new-r theta dr color) HR)))))]
    (big-bang INIT
              (on-tick suivant)
              (on-draw dessiner))))

(void (blackhole))
(printf "Et : ")
