;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname cc2-gr3-jpr) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write repeating-decimal #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; cc2-gr3.rkt
;;; Fac Sciences Nice, L1-Info, Printemps 2017
(require net/sendurl)

;;; Question 1a

(define (set-add x E)
  (if (member x E) E (cons x E)))

(show (set-add 3 '(1 2 3)))
(show (set-add 8 '(1 2 3)))

;;; Question 1b

(define (list->set L)              ; recursive enveloppee
  (cond ((empty? L) empty)
        ((member (first L) (rest L)) (list->set (rest L)))
        (else (cons (first L) (list->set (rest L))))))

(show (list->set '(1 2 1 2 3 1 2 3 4)))

;;; Question 1c

(define (list->set_ L)             ; iterative
  (local [(define (iter L acc)
            (cond ((empty? L) (reverse acc))
                  ((member (first L) (rest L)) (iter (rest L) acc))
                  (else (iter (rest L) (cons (first L) acc)))))]
    (iter L empty)))

(define (list->set__ L)            ; ordre superieur
  (reduce (lambda (x hr) (if (member x hr) hr (cons x hr))) empty L))

;;; Question 2a

(define (partition L pred)
  (if (empty? L)
      (list empty empty)
      (local [(define L2 (partition (rest L) pred))]
        (if (pred (first L))
            (list (cons (first L) (first L2)) (second L2))
            (list (first L2) (cons (first L) (second L2)))))))

(show (partition '(les 2 ou 3 bateaux) number?))

; l'appel récursif à partition dans le local est exécuté AVANT les lignes qui
; suivent le local, donc ces lignes forment une enveloppe...

;;; Question 2b

(define (partition-os L pred)            ; ordre superieur
  (list (filter pred L) (filter (lambda (x) (not (pred x))) L)))

(check-expect (partition-os '(les 2 ou 3 bateaux) number?)
              (partition '(les 2 ou 3 bateaux) number?))

;;; Question 3

(define (hyperspace)
  (local [(define FOND (rectangle 800 600 'solid "black"))
          (define-struct astre (x y dx dy))
          (define INIT empty)
          (define (random-astre)
            (make-astre 400 300 (- (random 101) 50) (- (random 101) 50)))
          (define (suivant L)
            (if (empty? L)
                (build-list 10 (lambda (i) (random-astre)))
                (local [(match-define (astre x y dx dy) (first L))]
                  (if (or (< x 0) (> x 800) (< y 0) (> y 600))
                      (suivant (rest L))
                      (cons (make-astre (+ x dx) (+ y dy) dx dy)
                            (suivant (rest L)))))))
          (define (dessiner L)
            (if (empty? L)
                FOND
                (local [(match-define (astre x y dx dy) (first L))] 
                  (scene+line (dessiner (rest L))
                              x y (+ x dx) (+ y dy) "white"))))]
    (big-bang INIT
              (on-tick suivant 1/20)
              (on-draw dessiner))))

(send-url "https://www.youtube.com/watch?v=TbTxEyYp6Qs")
(void (hyperspace))

