;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname cc2-gr4) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write mixed-fraction #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; cc2-gr4.rkt
;;; Fac Sciences Nice, L1-Info, Printemps 2017

;;; Question 1a

(define (polygone n c)                ; recursive enveloppe
  (if (= n 0)
      empty
      (cons (make-posn (random c) (random c))
            (polygone (- n 1) c))))

(define P (polygone 5 300))
(show P)

;;; Question 1b

(define (polygone_it n c)             ; iterative
  (local [(define (iter n acc)
            (if (= n 0)
                acc       ; inutile d'inverser, tout est aléatoire !
                (iter (- n 1) (cons (make-posn (random c) (random c)) acc))))]
    (iter n empty)))

(define P1 (polygone_it 5 300))
(show P1)

;;; Question 1c

(define (polygone_os n c)             ; ordre superieur
  (build-list n (lambda (i) (make-posn (random c) (random c)))))

(define P2 (polygone_it 5 300))
(show P1)

;;; Question 2a

(define (iterer f n x)
  (if (= n 0) x (f (iterer f (- n 1) x))))

;;; Question 2b

(check-expect (iterer sqr 3 2) 256)

;;; Question 2c

(define (iterer_it f n x)              ; iterative, sans local !
  (if (= n 0) x (iterer_it f (- n 1) (f x))))

(show (iterer_it sqr 3 2))

;;; Question 3

(define (anim)
  (local [(define FOND (add-line (add-line (rectangle 400 400 'solid "yellow")
                                           0 200 400 200 "black")
                                 200 0 200 200 "black"))
          (define-struct balle (x y dx dy col))
          (define (random-balle)
            (make-balle 200 0 0 (+ 2 (random 9)) (if (zero? (random 2)) "blue" "red")))
          ; le monde est une liste L de 30 balles
          (define INIT (build-list 30 (lambda (i) (random-balle))))
          (define (suivant L)
            (if (empty? L)
                L
                (local [(match-define (balle x y dx dy col) (first L))
                        (define xs (+ x dx))
                        (define ys (+ y dy))]
                  (cond ((< xs -10)         ; elle sort à gauche
                         (cons (random-balle) (suivant (rest L))))
                        ((> xs 410)         ; elle sort à droite
                         (suivant (rest L)))
                        ((not (= xs 200))   ; elle avance à l'horizontale sur BC ou BD
                         (cons (make-balle xs ys dx dy col) (suivant (rest L))))
                        ((> ys 200)         ; elle descend et va dépasser B !
                         (cons (if (equal? col "blue")
                                   (make-balle 200 200 (- dy) 0 col)
                                   (make-balle 200 200 dy 0 col))
                               (suivant (rest L))))
                        (else               ; elle descend à la verticale entre A et B
                         (cons (make-balle xs ys dx dy col) (suivant (rest L))))))))
          (define (dessiner L)
            (if (empty? L)
                FOND
                (local [(match-define (balle x y dx dy col) (first L))]
                  (place-image (circle 10 'solid col) x y (dessiner (rest L))))))
          (define (final? L)
            (empty? L))]
    (big-bang INIT
              (on-tick suivant)
              (on-draw dessiner)
              (stop-when final?))))

(void (anim))

                  






















#|
(define (anim)
  (local [(define FOND (above (rectangle 300 300 'solid "white")
                              (rectangle 300 200 'solid "lightblue")))
          (define-struct part (x y dy img))
          (define (random-part)
            (make-part (random 300) 0 (+ 2 (random 5))
                       (circle 5 'solid (list-ref '("blue" "red" "black" "yellow") (random 4)))))
          (define F #i0.9)
          ; le monde est une liste L de 40 particules
          (define INIT (build-list 40 (lambda (i) (random-part))))
          (define (suivant L)
            (if (empty? L)
                L
                (local [(match-define (part x y dy img) (first L))
                        (define ys (+ y dy))]
                  (cond ((> ys 500) (cons (random-part) (suivant (rest L))))
                        ((> ys 300) (cons (make-part x (+ y dy) (* F dy) img) (suivant (rest L))))
                        (else (cons (make-part x (+ y dy) (+ dy 1) img) (suivant (rest L))))))))
          (define (dessiner L)
            (if (empty? L)
                FOND
                (local [(match-define (part x y dy img) (first L))]
                  (place-image img x y (dessiner (rest L))))))]
    (big-bang INIT
              (on-tick suivant)
              (on-draw dessiner))))
                  
(void (anim))
|#


          
#|
;;; animation : trajectoires d'un systeme de 3 particules  <----- BBBBBBUUUUUUGGGGGG

(define (choose L)   ; un element au hasard dans une liste L
  (list-ref L (random (length L))))

(define (anim)
  (local [(define FOND (rectangle 400 400 'solid "yellow"))
          (define (in-canvas a)
            (max 0 (min 400 a)))
          ; une particule a une position (x,y), une vitesse (dx,dy) 
          (define-struct part (x y theta))
          (define (random-part)
            (make-part (+ 100 (random 200)) (+ 100 (random 200)) (* 2 pi (random))))
          (define BILLE (circle 2 'solid "red"))
          (define (small-random x)   ; dans ]-x,x[ flottant
            (- (* 2 x (random)) x))
          ; le monde est une liste de 3 particules, et une image
          (define-struct monde (L img))
          (define INIT (make-monde (build-list 2 (lambda (i) (random-part))) FOND))
          (define (suivant m)
            (local [(match-define (monde L img) m)
                    (define Ls (update-list L))
                    (define imgs (update-img img L Ls))]
              (make-monde Ls imgs)))
          (define (update-list L)
            (if (empty? L)
                L
                (local [(match-define (part x y theta) (first L))
                        (define xs (in-canvas (+ x (* 2 (cos theta)))))
                        (define ys (in-canvas (+ y (* 2 (sin theta)))))
                        (define thetas (+ theta (small-random 0.2)))]
                  (cons (make-part xs ys thetas) (update-list (rest L))))))
          (define (update-img img L Ls)
            (if (empty? L)
                img
                (local [(match-define (part x1 y1 _) (first L))
                        (match-define (part x2 y2 _) (first Ls))]
                  (update-img (scene+line img x1 y1 x2 y2 "black") (rest L) (rest Ls)))))
          (define (dessiner m)
            (monde-img m))]
    (big-bang INIT
              (on-tick suivant 1/5)
              (on-draw dessiner))))

(void (anim))

|#





















